package org.dromara.web.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.web.domain.bo.InvoiceRecordBo;
import org.dromara.web.domain.vo.InvoiceRecordVo;
import org.dromara.web.domain.InvoiceRecord;
import org.dromara.web.mapper.InvoiceRecordMapper;
import org.dromara.web.service.IInvoiceRecordService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 开票记录Service业务层处理
 *
 * @author Huanyi
 * @date 2025-08-15
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class InvoiceRecordServiceImpl implements IInvoiceRecordService {

    private final InvoiceRecordMapper baseMapper;

    /**
     * 查询开票记录
     *
     * @param id 主键
     * @return 开票记录
     */
    @Override
    public InvoiceRecordVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询开票记录列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 开票记录分页列表
     */
    @Override
    public TableDataInfo<InvoiceRecordVo> queryPageList(InvoiceRecordBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<InvoiceRecord> lqw = buildQueryWrapper(bo);
        Page<InvoiceRecordVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的开票记录列表
     *
     * @param bo 查询条件
     * @return 开票记录列表
     */
    @Override
    public List<InvoiceRecordVo> queryList(InvoiceRecordBo bo) {
        LambdaQueryWrapper<InvoiceRecord> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<InvoiceRecord> buildQueryWrapper(InvoiceRecordBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<InvoiceRecord> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(InvoiceRecord::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getNumber()), InvoiceRecord::getNumber, bo.getNumber());
        lqw.eq(StringUtils.isNotBlank(bo.getType()), InvoiceRecord::getType, bo.getType());
        lqw.like(StringUtils.isNotBlank(bo.getName()), InvoiceRecord::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getAdmissionId()), InvoiceRecord::getAdmissionId, bo.getAdmissionId());
        lqw.eq(bo.getProgress() != null, InvoiceRecord::getProgress, bo.getProgress());
        return lqw;
    }

    /**
     * 新增开票记录
     *
     * @param bo 开票记录
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(InvoiceRecordBo bo) {
        InvoiceRecord add = MapstructUtils.convert(bo, InvoiceRecord.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改开票记录
     *
     * @param bo 开票记录
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(InvoiceRecordBo bo) {
        InvoiceRecord update = MapstructUtils.convert(bo, InvoiceRecord.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(InvoiceRecord entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除开票记录信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
